=== examples/CMakeLists.txt ===
add_custom_target(examples)

add_subdirectory(sparse)
add_subdirectory(dense)
